package flutter.curiosity.tools

import android.content.pm.PackageManager
import android.util.Log
import androidx.core.content.ContextCompat
import flutter.curiosity.CuriosityPlugin.Companion.context
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel


object Tools {
    /**
     * 检测是否有权限
     */
    fun checkPermission(permission: String): Boolean {
        return ContextCompat.checkSelfPermission(context, permission) ==
                PackageManager.PERMISSION_DENIED
    }

    /**
     * 打印日志
     */
    fun logInfo(content: String) {
        Log.i("Curiosity--- ", content)
    }

    /**
     * 判断Argument是否为null
     */
    fun isArgumentNull(key: String, call: MethodCall, result: MethodChannel.Result, function: () -> Unit) {
        if (call.argument<Any>(key) == null) {
            result.error("null", "$key is not null", null);
            return
        } else {
            function()
        }
    }

    fun resultError(error: String?): String {
        return error ?: "error -- Parameter error"
    }

    fun resultError(): String {
        return "error -- Parameter error"
    }

    fun resultSuccess(success: String?): String {
        return success ?: "success"
    }

    fun resultNot(not: String?): String {
        return not ?: "null"
    }

    fun resultSuccess(): String {
        return "success"
    }


}
